<?php
/*
* $Id: wholeSaleLite.php
* $Loc: /includes/hooks/admin/catalog/
*
* Name: WholesaleLite
* Version: 4.7.9
* Release Date: 10/19/2024
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under the GNU General Public License
*
* Comments: Author: [Rainer Schmied @raiwa]
* Author URI: [www.phoenixcartaddons.com]
* 
* CE Phoenix, E-Commerce made Easy
* https://phoenixcart.org
* 
* Copyright (c) 2021 Phoenix Cart
* 
* 
*/

  class hook_admin_catalog_wholeSaleLite {
    
    
  function listen_infoBox($parameters) {
    global $product;
    
    $contents = &$parameters['contents'];

    if (isset($product) && ($product instanceof Product)) { // product info box contents
      if (DISPLAY_PRICE_WITH_TAX == 'true') {
        $ws_price = constant('MODULE_STORE_WHOLESALE_PRICE_GROSS_' . strtoupper($_SESSION['language'])) . ' ' . $product->format('ws_price') . '<br>';
      } else {
        $ws_price = constant('MODULE_STORE_WHOLESALE_PRICE_NET_' . strtoupper($_SESSION['language'])) . ' ' . $product->format('ws_price') . '<br>';
      }
      $insert_array[] = ['text' => $ws_price];
      $contents = array_merge( array_slice( $contents, 0, 5, true ), $insert_array, array_slice( $contents, 5, null, true ) );
    }

  }

    function listen_updateProductAction() {

      $sql_data_array['products_ws_price'] = (!Text::is_empty($_POST['products_ws_price'])) ? Text::input($_POST['products_ws_price']) : 'null';

      $GLOBALS['db']->perform('products', $sql_data_array, 'update', "products_id = '" . (int)$GLOBALS['products_id'] . "'");
    }

    function listen_preDuplicateCopyToConfirmAction($parameters) {
      
      $db_columns = &$parameters['db']['products']; 
      
      $db_columns['products_ws_price'] = null;
    }

    function listen_injectDataForm() {
      
      $product = product_by_id::administer($_GET['pID']);
      
                           
      $net_output = '<div class="form-group row">' . PHP_EOL;
      $net_output .= '  <label for="pWNet" class="col-form-label col-sm-3 text-left text-sm-right">' . constant('MODULE_STORE_WHOLESALE_PRICE_NET_' . strtoupper($_SESSION['language'])) . '</label>' . PHP_EOL;
      $net_output .= '  <div class="col-sm-9">';
      $net_output .=      (new Input('products_ws_price', ['id' => 'pWNet', 'class' => 'form-control w-25', 'onchange' => 'updateGrossWS()']))->default_value($product->get('ws_price') ?? '') . PHP_EOL;
      $net_output .= '  </div>' . PHP_EOL;
      $net_output .= '  </div>' . PHP_EOL;
      $net_output .= '  <div class="form-group row">' . PHP_EOL;
      $net_output .= '  <label for="pWGross" class="col-form-label col-sm-3 text-left text-sm-right">' . constant('MODULE_STORE_WHOLESALE_PRICE_GROSS_' . strtoupper($_SESSION['language'])) . '</label>' . PHP_EOL;
      $net_output .= '  <div class="col-sm-9">' . PHP_EOL;
      $net_output .=      (new Input('products_ws_price_gross', ['id' => 'pWGross', 'class' => 'form-control w-25', 'onchange' => 'updateNetWS()']))->default_value($product->get('ws_price') ?? '') . PHP_EOL;
      $net_output .= '  </div>' . PHP_EOL;
      $net_output .= '</div>' . PHP_EOL;

        
        $output = <<<EOD
<script>
function updateGrossWS() {
  var taxRate = getTaxRate();
  var grossValueWS = document.forms["new_product"].products_ws_price.value;

  if (taxRate > 0) {
    grossValueWS = grossValueWS * ((taxRate / 100) + 1);
  }

  document.forms["new_product"].products_ws_price_gross.value = doRound(grossValueWS, 4);
}

function updateNetWS() {
  var taxRate = getTaxRate();
  var netValueWS = document.forms["new_product"].products_ws_price_gross.value;

  if (taxRate > 0) {
    netValueWS = netValueWS / ((taxRate / 100) + 1);
  }

  document.forms["new_product"].products_ws_price.value = doRound(netValueWS, 4);
}

  $('select[name="products_tax_class_id"]').change(updateGrossWS);
  
  updateGrossWS();
</script>
EOD;

        return $net_output . $output;
      
      }

  }
