<?php
/*
* $Id: wholeSale.php
* $Loc: /includes/hooks/admin/siteWide/
*
* Name: WholesaleLite
* Version: 4.7.9
* Release Date: 10/19/2024
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under the GNU General Public License
*
* Comments: Author: [Rainer Schmied @raiwa]
* Author URI: [www.phoenixcartaddons.com]
* 
* CE Phoenix, E-Commerce made Easy
* https://phoenixcart.org
* 
* Copyright (c) 2021 Phoenix Cart
* 
* 
*/

class hook_admin_siteWide_wholeSale {

  public $version = '4.7.0';

  function listen_constructPaginator( $param ) {
    global $table_definition;

    if ( Request::get_page() == 'customers.php' && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' ) {
      $index = (int)array_search(TABLE_HEADING_ACTION, array_column($table_definition['columns'], 'name'));
      array_splice($table_definition['columns'], $index, 0, [[
        'name' => HOOK_WOLESALE_PR_HEADER_TITLE_GROUP,
        'class' => 'text-center',
        'function' => function (&$row) {
          if ($row['customers_wholesale'] > 0) {
            return  constant('MODULE_STORE_WHOLESALE_ENTRY_WHOLESALE_' . strtoupper($_SESSION['language']));
          } else {
            return  MODULE_CUSTOMER_DATA_WHOLESALE_ENTRY_RETAIL;
          }
        },
      ]]);
    }

  }

  function listen_injectSiteEnd() {
                                                   
    if ( Request::get_page() == 'products_attributes.php' && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' ) {
        global $attributes_query, $action;

        $attributes_values = $attributes_query->data_seek(0);

        $output = PHP_EOL . <<<EOD
<script>
$(function() {
EOD;

        $header_title_wholesale = constant('MODULE_STORE_WHOLESALE_ENTRY_WHOLESALE_' . strtoupper($_SESSION['language']));

        $output .= PHP_EOL . <<<EOD
$('table:eq(0) thead tr th:nth-child(4)').after('<th class="text-right">{$header_title_wholesale}</th>');
EOD;

        $row_id = 0;
        while ( $attributes_values = $attributes_query->fetch_assoc() ) {

          $products_name_only = Product::fetch_name($attributes_values['products_id']);

          if (($action == 'update_attribute') && ($_GET['attribute_id'] == $attributes_values['products_attributes_id'])) {

            $wholesale_input = '<td class="text-center"><input class="form-control" type="text" name="value_ws_price" value="' . $attributes_values['options_values_ws_price'] . '" style="width:100px"></td>';

            $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr td input[name="value_price"]').closest('td').after('{$wholesale_input}');
EOD;

          } else {

            $wholesale_output = '<td class="text-right">' . $attributes_values["options_values_ws_price"] . '</td>';

            $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr:eq({$row_id}) td:nth-child(4)').after('{$wholesale_output}');
EOD;

          }

          $row_id ++;

        }

        if ($action != 'update_attribute') {

          $wholesale_input = '<td class="text-center"><input class="form-control" type="text" name="value_ws_price" value="0" style="width:100px"></td>';

          $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr td input[name="value_price"]').closest('td').after('{$wholesale_input}');
EOD;
        }


        $output .= PHP_EOL . <<<EOD
});
</script>
EOD;

      return $output;

    }
  }

}
